#include <iostream.h>  // constructeur par recopie
#include <conio.h>

class  pile_entier
{
private :
int *pile,taille,hauteur;
public:
pile_entier(int n); // constructeur, taille de la pile
pile_entier(pile_entier &p);  // constructeur par recopie
~pile_entier(); // destructeur
void empile(int p);  // ajoute un element
int depile();  // depile un element
int pleine(); // 1 si vrai   0 sinon
int vide();  // 1 si vrai  0 sinon
};

pile_entier::pile_entier(int n=20)  // taille par defaut: 20
{taille = n;
pile = new int[taille];  // taille de la pile
hauteur = 0;
cout<<"On a fabrique une pile de "<<taille<<" elements\n";
cout<<"Adresse de la pile: "<<pile<<" et de l'objet: "<<this<<"\n";}

pile_entier::pile_entier(pile_entier &p)
{taille = p.taille; hauteur = p.hauteur;
pile=new int[taille];
for(int i=0;i<hauteur;i++)*(pile+i) = p.pile[i];
cout<<"On a fabrique une pile de "<<taille<<" elements\n";
cout<<"Adresse de la pile: "<<pile<<" et de l'objet: "<<this<<"\n";}

pile_entier::~pile_entier()
{delete pile;}  // libere la place

void pile_entier::empile(int p)
{*(pile+hauteur) = p;hauteur++;}

int pile_entier::depile()
{int res;hauteur--;res=*(pile+hauteur);return res;}

int pile_entier::pleine()
{if(hauteur==taille)return 1;return 0;}

int pile_entier::vide()
{if(hauteur==0)return 1;return 0;}

void main()
{ cout<<"Pile a:\n";pile_entier a(10);
for(int i=0;a.pleine()!=1;i++)a.empile(2*i);
cout<<"Pile b:\n";
pile_entier b = a;
while(b.vide()!=1)cout<<b.depile()<<"  ";
getch();}
