#include <iostream.h>   // Gestion d'une pile d'entiers
#include <conio.h>

class  pile_entier
{
private :
int *pile,taille,hauteur;
public:
pile_entier(int n); // constructeur, taille de la pile
~pile_entier(); // destructeur
void empile(int p);  // ajoute un element
int depile();  // depile un element
int pleine(); // 1 si vrai   0 sinon
int vide();  // 1 si vrai  0 sinon
};

pile_entier::pile_entier(int n=20)  // taille par defaut: 20
{taille = n;
pile = new int[taille];  // taille de la pile
hauteur = 0;
cout<<"On a fabrique une pile de "<<taille<<" elements\n";}

pile_entier::~pile_entier()
{delete pile;}  // libere la place

void pile_entier::empile(int p)
{*(pile+hauteur) = p;hauteur++;}

int pile_entier::depile()
{int res; hauteur--; res = *(pile+hauteur); return res;}

int pile_entier::pleine()
{if(hauteur==taille)return 1;return 0;}

int pile_entier::vide()
{if(hauteur==0)return 1;return 0;}


 void main()
 { pile_entier a,b(15);   // pile automatique
   a.empile(8);
 if(a.vide()==1) cout<<"a vide\n";else cout<<"a non vide\n";

 pile_entier *adp;          // pile dynamique
 adp = new pile_entier(5);  // pointeur sur une pile de 5 entiers
 for(int i=0;adp->pleine()!=1;i++) adp->empile(10*i);
 cout<<"\nContenu de la pile dynamique:\n";
 for(int i=0;i<5;i++)if(adp->vide()!=1)cout<<adp->depile()<<"\n";
 getch();
 }


